/*
	Community HL-HEV | All for Half-Life (https://hl-hev.ru)
	Plugin : [HLZM] Flare
	Author : BIGs
	Thanks - HL-HEV Team
*/
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>


#pragma semicolon 1
#pragma ctrlchar  '\'

#define pev_flare pev_iuser4
#define flare_id 1337
#define is_ent_flare(%1) (pev(%1, pev_flare) == flare_id) ? 1 : 0

new const flare_model[] = "models/w_flare.mdl";

const DMG_HEGRENADE = (1<<24);

#define V_MODEL "models/v_flare.mdl"
#define W_MODEL "models/w_flare.mdl"
#define P_MODEL "models/p_flare.mdl"

public plugin_init()
{
	register_plugin("[HLZM] Flare", "1.0.4", "BIGs | HL-HEV Team");
	register_forward(FM_SetModel, "explosive_model_stuff");
	register_forward(FM_Think, "explosive_think");
	register_event("CurWeapon", "Event_CurWeapon", "be","1=1");
	

}
public Event_CurWeapon(id)
{
	new weaponID = read_data(2);
	
	if(weaponID != HLW_HANDGRENADE)
	return PLUGIN_CONTINUE;
	
	set_pev(id, pev_viewmodel2, V_MODEL);
	set_pev(id, pev_weaponmodel2, P_MODEL);
	return PLUGIN_CONTINUE;
}
public plugin_precache()
{
	engfunc(EngFunc_PrecacheModel, V_MODEL);
	engfunc(EngFunc_PrecacheModel, W_MODEL);
	engfunc(EngFunc_PrecacheModel, P_MODEL);
}
public explosive_model_stuff(ent, const model[]) 
{
	if(!pev_valid(ent) || !equal(model[9], "grenade.mdl"))
		return FMRES_IGNORED;

	static Float:light_origin[3]  ;

	pev(ent,pev_origin,light_origin);

	static classname[32]; pev(ent, pev_classname, classname, 31);

	if(equal(classname, "grenade"))
	{
		engfunc(EngFunc_SetModel, ent, flare_model);

		set_task(0.1, "make_flare_flash", ent);

		set_pev(ent, pev_flare,   flare_id);

		set_pev(ent, pev_nextthink, get_gametime() + 40);
		
		
		
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}
public make_flare_flash(ent) 
{
	if(!pev_valid(ent))
		return FMRES_IGNORED;

	static Float:light_origin[3] ;
 
	pev(ent,pev_origin,light_origin);

	static classname[32]; pev(ent, pev_classname, classname, 31);

	if(equal(classname, "grenade"))
        {
		engfunc(EngFunc_SetModel, ent, flare_model);
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
		write_byte(27) ;
		engfunc(EngFunc_WriteCoord,light_origin[0]) ;
		engfunc(EngFunc_WriteCoord,light_origin[1]) ;
		engfunc(EngFunc_WriteCoord,light_origin[2]) ;
		write_byte(22);	// radius
		write_byte(237); // r
		write_byte(247); // g
		write_byte(35); // b
		write_byte(3); 	// life
		write_byte(0);	// rate
		message_end();
		set_task(0.1,"make_flare_flash",ent);
		
		return FMRES_SUPERCEDE;
        }
	return FMRES_IGNORED;
}

public explosive_think(ent) 
{
      if(pev_valid(ent) && is_ent_flare(ent))
      {
	  engfunc(EngFunc_RemoveEntity, ent);
      }
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1058\\ f0\\ fs16 \n\\ par }
*/
